'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mkdirpObservable = exports.writeFileObservable = exports.readFileObservable = exports.createSymlinkObservable = exports.createNewSymlinkObservable = exports.unlinkObservable = undefined;

var _Rx = require('rxjs/Rx');

var _Rx2 = _interopRequireDefault(_Rx);

var _fs = require('fs');

var fs = _interopRequireWildcard(_fs);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const mkdirp = require('mkdirp');

const unlinkObservable = exports.unlinkObservable = path => _Rx2.default.Observable.create(observer => {
  if (fs.existsSync(path)) {
    fs.unlink(path, error => {
      if (error) {
        observer.error(error);
      } else {
        observer.next();
        observer.complete();
      }
    });
  } else {
    observer.next();
    observer.complete();
  }
});

const createNewSymlinkObservable = exports.createNewSymlinkObservable = _Rx2.default.Observable.bindNodeCallback(fs.symlink);

const createSymlinkObservable = exports.createSymlinkObservable = (target, path) => unlinkObservable(path).flatMap(() => createNewSymlinkObservable(target, path));

const readFileObservable = exports.readFileObservable = _Rx2.default.Observable.bindNodeCallback(fs.readFile);

const writeFileObservable = exports.writeFileObservable = _Rx2.default.Observable.bindNodeCallback(fs.writeFile);

const mkdirpObservable = exports.mkdirpObservable = _Rx2.default.Observable.bindNodeCallback(mkdirp);